<?php
/**
 * Created by JetBrains PhpStorm.
 * User: geovanesantos
 * Date: 29/05/14
 * Time: 11:14
 * To change this template use File | Settings | File Templates.
 */

namespace Scheduler\Logic;

//require_once __DIR__.'../../../../../projects/scheduler/public/bootstrap.php';

use \Setforms2\Runtime\Helper\Procedure;
use \Setforms2\Runtime\Helper\Procedure\Param;


class ScheduledEmail {

    const QUEUE_QUERY="INSERT INTO TKU_PROCESS_QUEUE (TKU_PROCESS_QUEUE_ID, NRORG, NAME, TKU_PROCESS_ID, STATUS, PROCESS_PARAMS, PRIORITY, MINUTOS_EXEC, HORAS_EXEC, DIAS_MES_EXEC, MESES_EXEC, DIAS_SEM_EXEC, CDOPERADOR)
VALUES (:P_ID, :P_NRORG, :P_NAME, 3, :P_STATUS, :P_PARAMS, :P_PRIORITY, :P_MINUTOS, :P_HORAS, :P_DIAS_MES, :P_MESES, :P_DIAS_SEM, 000000000999)";

    private $sender;
    private $recipient;
    private $subject;
    private $body;
    private $attachment;
    private $template;
    private $nrorg=1;
    private $priority=5;

    public function setPriority($priority)
    {
        $this->priority = $priority;
    }

    public function getPriority()
    {
        return $this->priority;
    }

    public function setNrorg($nrorg)
    {
        $this->nrorg = $nrorg;
    }

    public function getNrorg()
    {
        return $this->nrorg;
    }

    public function setTemplate($template)
    {
        $this->template = $template;
    }

    public function getTemplate()
    {
        return $this->template;
    }

    public function setBody($body)
    {
        $this->body = $body;
    }

    public function getBody()
    {
        return $this->body;
    }

    protected function setRecipient($recipient)
    {
        $this->recipient = $recipient;
    }

    public function getRecipient()
    {
        return $this->recipient;
    }

    public function setSender($sender)
    {
        $this->sender = $sender;
    }

    public function getSender()
    {
        return $this->sender;
    }

    public function setSubject($subject)
    {
        $this->subject = $subject;
    }

    public function getSubject()
    {
        return $this->subject;
    }

    public function setAttachment($attachment)
    {
        $this->attachment = $attachment;
    }

    public function getAttachment()
    {
        return $this->attachment;
    }


    public function addRecipient($recipient){
        $this->recipient.=$recipient.",";
    }

    public function enviaEmail(){

        $db = \Setforms2\Runtime\Connection::getInstance();

        $arrayEmail=Array();
        $arrayEmail["SENDER"]=$this->getSender();
        $arrayEmail["RECIPIENT"]=rtrim($this->getRecipient(),",");
        $arrayEmail["SUBJECT"]=$this->getSubject();
        $arrayEmail["BODY"]=$this->getBody();
        $arrayEmail["TEMPLATE"]=$this->getTemplate();

        $nrorg=$this->getNrorg();
        $priority=$this->getPriority();

        $jsonEmail=json_encode($arrayEmail);
        $encodedJson=htmlspecialchars($jsonEmail);

        $procedure=new Procedure("NOVO_CODIGO");
        $procedure->addParam(new Param("P_CONTADOR","I","TKU_PROCESS_QUEUE","2",100));
        $procedure->addParam(new Param("P_SEQUENCIAL","O",null,"2",20));
        $returnArray=$procedure->call();
        $pk=ltrim(array_pop($returnArray), '0');

        $arrayParams=Array(
            'P_ID' => $pk,
            'P_STATUS' => $status='EXECUCAO',
            'P_NRORG' => $nrorg,
            'P_NAME' => $name="processo_email_$pk",
            'P_PRIORITY' => $priority,
            'P_PARAMS' => $encodedJson,
            'P_MINUTOS' => $min='*',
            'P_HORAS' => $hr='*',
            'P_DIAS_MES' => $day='*',
            'P_MESES' => $mon='*',
            'P_DIAS_SEM' => $dwk='*',
        );

        $db->execute(self::QUEUE_QUERY, $arrayParams);

    }

    public function agendaEmail($cronString){

        $db = \Setforms2\Runtime\Connection::getInstance();

        $arrayEmail=Array();
        $arrayEmail["SENDER"]=$this->getSender();
        $arrayEmail["RECIPIENT"]=substr($this->getRecipient(),0,-1);
        $arrayEmail["SUBJECT"]=$this->getSubject();
        $arrayEmail["BODY"]=$this->getBody();

        $nrorg=$this->getNrorg();
        $priority=$this->getPriority();


        $jsonEmail=json_encode($arrayEmail);
        $encodedJson=htmlspecialchars($jsonEmail);

        $cronArray=explode(" ", $cronString);

        $procedure=new Procedure("NOVO_CODIGO");
        $procedure->addParam(new Param("P_CONTADOR","I","TKU_PROCESS_QUEUE","2",100));
        $procedure->addParam(new Param("P_SEQUENCIAL","O",null,"2",20));
        $returnArray=$procedure->call();
        $pk=ltrim(array_pop($returnArray), '0');

        $arrayParams=Array(
            'P_ID' => $pk,
            'P_STATUS' => 'AGENDADO',
            'P_NRORG' => $nrorg,
            'P_NAME' => "processo_email_$pk",
            'P_PRIORITY' => $priority,
            'P_PARAMS' => $encodedJson,
            'P_MINUTOS' => $cronArray[0],
            'P_HORAS' => $cronArray[1],
            'P_DIAS_MES' => $cronArray[2],
            'P_MESES' => $cronArray[3],
            'P_DIAS_SEM' => $cronArray[4],
        );

        $db->execute(self::QUEUE_QUERY, $arrayParams);
        \Scheduler\Logic\JobDeleter::deleteJob($pk);
        \Scheduler\Logic\Scheduler::criaXML($pk, $cronString);


    }

}


//$email=new ScheduledEmail();
//$email->setSender('donotreply@teknisa.com');
//$email->addRecipient('giovanni.salvador@teknisa.com');
//$email->setSubject('teste');
//$email->setBody('oi');
//$email->enviaEmail();
//$email->setBody('tchau');
//$email->agendaEmail('*/5 * * * *');